summaryrefslogtreecommitdiff
path: root/hooks
diff options
context:
space:
mode:
authorAaron Griffin <aaron@archlinux.org>2006-09-29 06:19:06 +0000
committerAaron Griffin <aaron@archlinux.org>2006-09-29 06:19:06 +0000
commit49284a96faf1c29b6b05ac70ea5c2ecda03fa75f (patch)
tree150d9275d07fec99ceb66f4584a980bbf9b2ff62 /hooks
parent2b5cd0819fdf0d3f408f3e9d72060b90f4320c38 (diff)
git-svn-id: http://phraktured.net/archiso@15 00a9fe69-e71b-0410-bb23-df0e5024db41
Diffstat (limited to 'hooks')
-rw-r--r--hooks/archiso51
-rw-r--r--hooks/boot-cd30
-rw-r--r--hooks/boot-usb30
3 files changed, 111 insertions, 0 deletions
diff --git a/hooks/archiso b/hooks/archiso
new file mode 100644
index 0000000..c60df2b
--- /dev/null
+++ b/hooks/archiso
@@ -0,0 +1,51 @@
+# vim: set ft=sh:
+run_hook ()
+{
+ if [ "x${ramdisk_size}" = "x" ]; then
+ ramdisk_size="75%"
+ fi
+ msg -n ":: Mounting tmpfs, size=${ramdisk_size}..."
+ mount -t tmpfs -o "size=${ramdisk_size}" tmpfs /tmpfs
+ mkdir /tmpfs/bootcd
+ msg "done."
+
+ if [ "x${BOOT_MOUNT}" -eq "x" ]; then
+ echo "ERROR: BOOT_MOUNT is not set. The boot-cd or boot-usb hook MUST"
+ echo " be run before this one. This image was improperly built"
+ exit 1
+ fi
+
+ squashimg="${BOOT_MOUNT}/archiso.sqfs"
+ if [ "${copytoram}" = "y" ]; then
+ /bin/cat ${squashimg} > /tmpfs/archiso.sqfs
+ squashimg="/tmpfs/archiso.sqfs"
+ fi
+
+ msg ":: Mounting squashfs image"
+ /bin/modprobe -q squashfs >/dev/null 2>&1
+ /bin/mkdir -p /tmpfs/squashfs_root
+ if ! /bin/losetup /dev/loop0 "${squashimg}" >/dev/null 2>&1; then
+ echo "ERROR: Cannot mount loop device /dev/loop0...aborting"
+ exit 1
+ fi
+
+ /bin/mount -r -t squashfs /dev/loop0 /tmpfs/squashfs_root
+
+ msg ":: Mounting root (union) filesystem"
+ /bin/modprobe -q unionfs >/dev/null 2>&1
+ /bin/mount -t unionfs -o dirs=/tmpfs=rw:/tmpfs/squashfs_root=ro none /real_root
+
+ if [ -d /proc/sys/dev/cdrom ]; then
+ echo 0 > /proc/sys/dev/cdrom/lock
+ echo 1 > /proc/sys/dev/cdrom/autoeject
+ fi
+
+ udevpid=$(/bin/minips -C udevd -o pid=)
+ [ "x${udevpid}" != "x" ] && /bin/kill -9 $udevpid 2>&1 >/dev/null
+ #Yep, we're bailing out here. We don't need kinit.
+ msg ":: Passing control to Archlinux Initscripts...Please Wait"
+ /bin/umount /sys
+ /bin/umount /proc
+ /bin/umount /dev
+ exec /bin/run-init -c /dev/console /real_root /sbin/init ${CMDLINE}
+}
diff --git a/hooks/boot-cd b/hooks/boot-cd
new file mode 100644
index 0000000..d6d9da6
--- /dev/null
+++ b/hooks/boot-cd
@@ -0,0 +1,30 @@
+# vim: set ft=sh:
+run_hook ()
+{
+ msg ":: Scanning for boot cdrom device..."
+
+ /bin/mkdir -p /tmpfs/bootmnt
+ bootmnt="/tmpfs/bootmnt/"
+ found=0
+
+ /bin/modprobe -q isofs >/dev/null 2>&1
+ for cdrom in /dev/cd/*; do
+ if mount -r -t iso9660 "${cdrom}" ${bootmnt} >/dev/null 2>&1; then
+ if [ -e "${bootmnt}/archiso.sqfs" ]; then
+ found=1
+ msg "${cdrom}"
+ break
+ fi
+ else
+ echo "Failed to mount ${cdrom}"
+ fi
+ [ ${found} -eq 0 ] && umount ${bootmnt} >/dev/null 2>&1
+ done
+
+ if [ ${found} -eq 0 ]; then
+ echo "ERROR: cannot find booted cdrom device, cannot continue..."
+ exit 1
+ else
+ export BOOT_MOUNT="${bootmnt}"
+ fi
+}
diff --git a/hooks/boot-usb b/hooks/boot-usb
new file mode 100644
index 0000000..9898ff6
--- /dev/null
+++ b/hooks/boot-usb
@@ -0,0 +1,30 @@
+# vim: set ft=sh:
+run_hook ()
+{
+ msg ":: Scanning for boot usb device..."
+
+ /bin/mkdir -p /tmpfs/bootmnt
+ bootmnt="/tmpfs/bootmnt/"
+ found=0
+
+ for usb in /dev/sd[a-z][0-9]; do
+ if mount -r -t vfat "${usb}" ${bootmnt} >/dev/null 2>&1 ||\
+ mount -r -t ext2 "${usb}" ${bootmnt} >/dev/null 2>&1; then
+ if [ -e "${bootmnt}/archiso.sqfs" ]; then
+ found=1
+ msg "${usb}"
+ break
+ fi
+ else
+ echo "Failed to mount ${usb}"
+ fi
+ [ ${found} -eq 0 ] && umount ${bootmnt} >/dev/null 2>&1
+ done
+
+ if [ ${found} -eq 0 ]; then
+ echo "ERROR: cannot find booted usb device, cannot continue..."
+ exit 1
+ else
+ export BOOT_MOUNT="${bootmnt}"
+ fi
+}